Public Class ClsList(Of T)
    Implements Generic.IEnumerable(Of T)

    Private mList As New List(Of T)
#Region "Constructeur et destructeur"

    Public Sub New()
        'e
    End Sub

    Protected Overrides Sub Finalize()
        mList.Clear()
        mList = Nothing
        MyBase.Finalize()
    End Sub
#End Region

#Region "Accs  la liste"

    Public Sub Add(ByVal pValue As T)
        SyncLock mList
            mList.Add(pValue)
        End SyncLock
    End Sub

    Public Sub AddRange(ByVal pValue As ClsList(Of T))
        mList.AddRange(pValue.mList)
    End Sub

    Public Sub Remove(ByVal pValue As T)
        SyncLock mList
            mList.Remove(pValue)
        End SyncLock
    End Sub

    Public Sub RemoveAt(ByVal pIndex As Integer)
        SyncLock mList
            mList.RemoveAt(pIndex)
        End SyncLock
    End Sub

    Public ReadOnly Property Count() As Integer
        Get
            Return mList.Count
        End Get
    End Property

    Default Public ReadOnly Property Item(ByVal pIndex As Integer) As T
        Get
            SyncLock mList
                Return mList(pIndex)
            End SyncLock
        End Get
    End Property

    Public Sub Clear()
        mList.Clear()
    End Sub
#End Region

#Region "implementations"

    Public Function GetEnumerator() As System.Collections.Generic.IEnumerator(Of T) Implements System.Collections.Generic.IEnumerable(Of T).GetEnumerator
        Return mList.GetEnumerator()
    End Function

    Public Function GetEnumerator1() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return mList.GetEnumerator
    End Function
#End Region
End Class
