Friend Class CtlInfoFichier

    Delegate Sub SetTextCallback(ByVal pNewFile As ClsFichier)

    Private WithEvents mAudio As ClsAudio = Nothing
    Private mActRead As ClsFichier = Nothing
    Private mModifFic As ClsFichier = Nothing

    Public Event PauseMusic()
    Public Event NextTitle()


    Public Property Audio() As ClsAudio
        Get
            Return mAudio
        End Get
        Set(ByVal value As ClsAudio)
            mAudio = value
            RefreshValues()
        End Set
    End Property

    Private Property ActRead() As ClsFichier
        Get
            Return mActRead
        End Get
        Set(ByVal value As ClsFichier)
            mActRead = value
            RefreshValues()
        End Set
    End Property

    Private Sub RefreshValues()
        If mModifFic Is Nothing Then
            If mActRead IsNot Nothing Then
                TxtTitle.Text = mActRead.Title
                TxtInter.Text = mActRead.Auteur
                TxtAlbum.Text = mActRead.Album
            Else
                TxtTitle.Text = "Non accessible"
                TxtInter.Text = "Non accessible"
                TxtAlbum.Text = "Non accessible"
            End If
        ElseIf mModifFic IsNot mActRead Then
            '            CmdModif.Text = "Charger le titre actuel"
        End If
    End Sub

    Private Sub mAudio_NewFile(ByVal pNewFile As ClsFichier) Handles mAudio.NewFile
        If TxtTitle.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf mAudio_NewFile)
            Me.Invoke(d, New Object() {pNewFile})
        Else
            ActRead = pNewFile
        End If
    End Sub

    Private Sub Ctl_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TxtTitle.KeyDown, TxtInter.KeyDown, TxtAlbum.KeyDown
        If Keys.Pause = e.KeyCode Or (e.Control And e.KeyCode = Keys.P) Then
            RaiseEvent PauseMusic()
            'ElseIf (e.Control And e.KeyCode = Keys.S) Then
            '    If CmdSave.Enabled = True Then CmdSave_Click(Nothing, Nothing)
            'ElseIf e.KeyCode = Keys.Escape Then
            '    If CmdModif.Enabled = True Then CmdModif_Click(Nothing, Nothing)
        ElseIf (e.Control And e.KeyCode = Keys.N) Then
            RaiseEvent NextTitle()
        End If
    End Sub

End Class
