Friend Class FrmPrinc
    Delegate Sub SetTextCallback(ByVal pNewFile As ClsFichier)

    Private WithEvents mAudio As New ClsAudio
    Private Delegate Sub MethodAction()

    Private mPrecFile As ClsFichier = Nothing
    Private mInSelectTV As Boolean = False

    Private Sub FrmPrinc_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        CreateLog("LectMP3", "1.02", "Lecteur de fichiers musicaux")

        MdlFriend.Analyse()

        My.Settings.Reload()

        Me.Location = My.Settings.FormPos
        Me.Size = My.Settings.FormSize
        Me.WindowState = CType(My.Settings.WindowState, FormWindowState)
        DocXml.Audio = mAudio
        CtlText.Audio = mAudio
        CtlInfoFichier.Audio = mAudio
        TVAlbum.Nodes.Clear()
        TVAlbum.Nodes.Add(MdlFriend.DocXml.GetTreeNode)
        TVAlbum.ExpandAll()
    End Sub

    Private Sub FrmPrinc_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If DocXml IsNot Nothing Then
            DocXml.Dispose()
            DocXml = Nothing
        End If
        'If mKeyboard IsNot Nothing Then mKeyboard.StopThread()
        'mKeyboard = Nothing
        If mAudio IsNot Nothing Then mAudio.StopThread()
        mAudio = Nothing

        If Me.WindowState = FormWindowState.Maximized Then
            My.Settings.WindowState = FormWindowState.Maximized
        ElseIf Me.WindowState = FormWindowState.Normal Then
            My.Settings.FormSize = Me.Size
            My.Settings.WindowState = FormWindowState.Normal
            My.Settings.FormPos = Me.Location
        End If
        CloseLog(True)
    End Sub

    Private Sub TRefresh_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TRefresh.Tick
        If LstFicHeard.Visible = False And ChkShowSeparate.Checked Then
            Dim lInt As Integer = LstFic.Height \ 2
            LstFicHeard.Visible = ChkShowSeparate.Checked
            LstFicHeard.Height = lInt
        ElseIf LstFicHeard.Visible And ChkShowSeparate.Checked = False Then
            LstFicHeard.Visible = ChkShowSeparate.Checked
        End If
        If mAudio IsNot Nothing Then
            If (Me.LstFic.Items.Count <> (mAudio.ToRead.Count + mAudio.Readed.Count)) AndAlso (mAudio.Reading Is Nothing OrElse (LstFic.Items.Count <> (mAudio.ToRead.Count + mAudio.Readed.Count + 1))) And ChkShowSeparate.Checked = False Then
                LstFic.Items.Clear()
                LstFic.Items.AddRange(mAudio.ToRead.ToArray)
                LstFic.Items.AddRange(mAudio.Readed.ToArray)
                If mAudio.Reading IsNot Nothing Then LstFic.Items.Add(mAudio.Reading)
                GPLstFic.Text = "Liste des fichiers (" + CStr(LstFic.Items.Count) + "), reste " + CStr(mAudio.ToRead.Count) + "  lire"
            End If
            If (LstFic.Items.Count <> mAudio.ToRead.Count Or LstFicHeard.Items.Count <> mAudio.Readed.Count) AndAlso ChkShowSeparate.Checked Then
                LstFic.Items.Clear()
                LstFic.Items.AddRange(mAudio.ToRead.ToArray)
                LstFicHeard.Items.Clear()
                LstFicHeard.Items.AddRange(mAudio.Readed.ToArray)
                GPLstFic.Text = "Liste des fichiers (" + CStr(LstFic.Items.Count + LstFicHeard.Items.Count + IIF(mAudio.Reading IsNot Nothing, 1, 0)) + "), reste " + CStr(mAudio.ToRead.Count) + "  lire"
            End If
        End If
        If mPrecFile Is Nothing OrElse mAudio Is Nothing Then
            Me.LblFile.Text = "Aucun titre ne joue actuellement"
            Me.PB.Maximum = 2
            Me.PB.Minimum = 0
            Me.PB.Value = 1
            Me.TT.SetToolTip(PB, "Aucune lecture en cours")
            Exit Sub
        Else
            Try
                PB.Maximum = CInt(mAudio.TimeTotal)
                PB.Minimum = 0
                PB.Value = CInt(mAudio.TimeElapsed)
                TT.SetToolTip(PB, GetHMS(CInt(mAudio.TimeElapsed)) + " / " + GetHMS(CInt(mAudio.TimeTotal)))
                TRefresh.Interval = 250
            Catch ex As Exception
                TRefresh.Interval = 3000
                AddLog("FrmPrinc.TRefresh_Tick", "Exception gre : " + ex.ToString, EPrio.Basse)
            End Try
        End If
    End Sub

    Private Function GetHMS(ByVal pSec As Integer) As String
        Dim lStr As String = ""
        lStr += Format(pSec Mod 60, "00")
        pSec = CInt((pSec - (pSec Mod 60)) / 60)
        If pSec > 0 Then
            lStr = Format(pSec Mod 60, "00") + ":" + lStr
            pSec = CInt((pSec - (pSec Mod 60)) / 60)
        End If
        If pSec > 0 Then
            lStr = CStr(pSec Mod 24) + ":" + lStr
            pSec = CInt((pSec - (pSec Mod 24)) / 24)
        End If
        Return lStr
    End Function

    Private Sub TVAlbum_AfterCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TVAlbum.AfterCheck
        If mInSelectTV Then Exit Sub
        mInSelectTV = True
        If e.Node.Tag IsNot Nothing AndAlso TypeOf e.Node.Tag Is ClsAlbum Then
            CType(e.Node.Tag, ClsAlbum).Selected = e.Node.Checked
            If e.Node.Checked = False Then TVAlbum.Nodes(0).Checked = False
        ElseIf e.Node Is TVAlbum.Nodes(0) Then
            For Each lNode As TreeNode In e.Node.Nodes
                CType(lNode.Tag, ClsAlbum).Selected = e.Node.Checked
            Next
        End If
        mInSelectTV = False
    End Sub

    Private Sub CmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdNext.Click, MnuSuivant.Click
        If mAudio IsNot Nothing Then
            mAudio.MusicStop()
        End If
    End Sub

    Private Sub LstFic_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LstFic.DoubleClick
        If LstFic.SelectedIndex > -1 AndAlso mAudio IsNot Nothing Then
            mAudio.Start(CType(LstFic.SelectedItem, ClsFichier))
        End If
    End Sub

    Private Sub LstFicHeard_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles LstFicHeard.DoubleClick
        If LstFicHeard.SelectedIndex > -1 AndAlso mAudio IsNot Nothing Then
            mAudio.Start(CType(LstFicHeard.SelectedItem, ClsFichier))
        End If
    End Sub

    Private Sub CmdPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdPlay.Click, MnuPause.Click
        If mAudio.IsPaused Then
            mAudio.MusicResume()
            CmdPlay.Image = My.Resources.Pause
        Else
            CmdPlay.Image = My.Resources.Play
            mAudio.Pause()
        End If
    End Sub

    Private Sub NI_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NI.MouseClick
        If e.Button <> Windows.Forms.MouseButtons.Left Then Exit Sub
        MnuShow_Click(Nothing, Nothing)
    End Sub

    Private Sub MnuShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuShow.Click
        Me.Visible = Not Me.Visible
        If Me.Visible = True Then Me.WindowState = CType(My.Settings.WindowState, FormWindowState)
        Application.DoEvents()
        Me.Select()
    End Sub

    Private Sub MnuClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MnuClose.Click
        Me.Close()
    End Sub

    Private Sub FrmPrinc_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Me.WindowState = FormWindowState.Normal Then My.Settings.FormPos = Me.Location
    End Sub

    Private Sub FrmPrinc_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.WindowState = FormWindowState.Minimized Then
            MnuShow_Click(Nothing, Nothing)
        ElseIf Me.WindowState = FormWindowState.Normal Then
            My.Settings.FormSize = Me.Size
            My.Settings.WindowState = FormWindowState.Normal
            My.Settings.FormPos = Me.Location
        Else
            My.Settings.WindowState = FormWindowState.Maximized
        End If
    End Sub

    Private Sub PauseMusic() Handles CtlText.PauseMusic, CtlInfoFichier.PauseMusic ', mKeyboard.PauseMusic
        If Me.InvokeRequired Then
            Dim d As New MethodAction(AddressOf PauseMusic)
            Me.Invoke(d)
        Else
            CmdPlay_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub NextTitle() Handles CtlText.NextTitle, CtlInfoFichier.NextTitle  ', mKeyboard.NextTitle
        If Me.InvokeRequired Then
            Dim d As New MethodAction(AddressOf NextTitle)
            Me.Invoke(d)
        Else
            CmdNext_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub Ctl_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles LstFic.KeyDown, TVAlbum.KeyDown, CmdNext.KeyDown, CmdPlay.KeyDown, CmdPrevious.KeyDown, CmdHelp.KeyDown, TBVolume.KeyDown, LstFicHeard.KeyDown, ChkShowSeparate.KeyDown
        If Keys.Pause = e.KeyCode Or (((sender IsNot Me.LstFic And sender IsNot Me.TVAlbum) Or e.Control) And e.KeyCode = Keys.P) Then
            PauseMusic()
        ElseIf ((sender IsNot Me.LstFic And sender IsNot Me.TVAlbum) Or e.Control) And e.KeyCode = Keys.N Then
            NextTitle()

        End If
    End Sub

    Private Sub CmdHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdHelp.Click
        My.Computer.FileSystem.WriteAllText(IO.Path.Combine(My.Application.Info.DirectoryPath, "ReadMe.txt"), My.Resources.Help, False)
        Diagnostics.Process.Start("notepad.exe", IO.Path.Combine(My.Application.Info.DirectoryPath, "ReadMe.txt"))
    End Sub

    Private Sub TBVolume_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TBVolume.Scroll
        mAudio.Volume = (TBVolume.Value - TBVolume.Maximum) * 100
        My.Settings.Volume = TBVolume.Value
    End Sub

    Private Sub mAudio_NewFile(ByVal pNewFile As ClsFichier) Handles mAudio.NewFile
        If Me.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf mAudio_NewFile)
            Me.Invoke(d, New Object() {pNewFile})
        Else
            GPLstFic.Text = "Liste des fichiers (" + CStr(LstFic.Items.Count + IIF(LstFicHeard.Visible, LstFicHeard.Items.Count + IIF(mAudio.Reading IsNot Nothing, 1, 0), 0)) + "), reste " + CStr(mAudio.ToRead.Count) + "  lire"
            mPrecFile = pNewFile
            If mPrecFile Is Nothing Then Exit Sub
            Me.LblFile.Text = mPrecFile.FileTitle
            If mPrecFile IsNot Nothing Then
                If mPrecFile.ToString.Length > 63 Then
                    NI.Text = Microsoft.VisualBasic.Left(mPrecFile.ToString, 60) + "..."
                Else
                    NI.Text = mPrecFile.ToString
                End If
            End If

        End If
    End Sub

    Private Sub GPLstFic_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles GPLstFic.Resize
        ChkShowSeparate.Left = GPLstFic.Width - ChkShowSeparate.Width
    End Sub
End Class
