Imports System.Xml
Friend MustInherit Class ClsBaseXml

    Private mNode As XmlNode
    Private mDocument As XmlDocument
    Private mParent As ClsBaseXml

    Protected Sub New(ByVal pDocument As XmlDocument)
        mNode = Nothing
        mDocument = pDocument
        mParent = Nothing
    End Sub

    Protected Sub New(ByVal pParent As ClsBaseXml, ByVal pNode As XmlNode)
        mParent = pParent
        mDocument = pParent.mDocument
        mNode = pNode
    End Sub

    Friend Overridable Sub Dispose()
        mParent = Nothing
        mNode = Nothing
        mDocument = Nothing
    End Sub

    Friend ReadOnly Property Node() As XmlNode
        Get
            Return mNode
        End Get
    End Property

    Friend ReadOnly Property Document() As XmlDocument
        Get
            Return mDocument
        End Get
    End Property

    Public ReadOnly Property Parent() As ClsBaseXml
        Get
            Return mParent
        End Get
    End Property

    Protected Sub ThrowDispose()
        If mDocument Is Nothing Then
            Throw New ObjectDisposedException("ClsBaseBddXml")
        End If
    End Sub

    Protected Function GetAttribut(ByVal pName As String) As String
        Dim lAttr As XmlNode = mNode.Attributes.GetNamedItem(pName)
        If lAttr Is Nothing Then
            Return ""
        Else
            Return lAttr.InnerText
        End If
    End Function

    Protected Sub SetAttribut(ByVal pName As String, ByVal pValue As String)
        Dim lAttr As XmlNode = mNode.Attributes.GetNamedItem(pName)
        If lAttr Is Nothing Then
            lAttr = mNode.Attributes.Append(Document.CreateAttribute(pName))
        End If
        lAttr.InnerText = pValue
    End Sub

    Protected Sub DelNode()
        If mParent IsNot Nothing AndAlso TypeOf mParent Is ClsAlbum Then
            DelNode(mParent.Node)
        Else
            DelNode(Document.DocumentElement)
        End If
    End Sub

    Private Sub DelNode(ByVal pNode As XmlNode)
        For i As Integer = 0 To pNode.ChildNodes.Count - 1
            If mNode IsNot Nothing AndAlso pNode.ChildNodes(i) Is mNode Then
                pNode.RemoveChild(mNode)
                Dispose()
                Exit Sub
            End If
        Next
    End Sub
End Class
